﻿package com.bezier{

	import flash.geom.Point;
	import flash.display.Sprite;


	import flash.geom.Point;
	import flash.events.Event;
	import com.events.UniversalEvent;

	import flash.events.MouseEvent;
	import flash.display.Sprite;
	import flash.display.Shape;
	
	public class GMA_Bezier extends Sprite{
		
		private var point_1:Point;
		private var point_2:Point;
		private var handle_1:Point;
		private var handle_2:Point;
		private var container:Object;
		private var handles:Array;
		private var points:Array;
		
		public function GMA_Bezier(containerObj:Sprite){
			container=containerObj;
		}
		
		public function draw(handle1_x:Number, handle1_y:Number, handle2_x:Number, handle2_y:Number, point1_x:Number, point1_y:Number, point2_x:Number, point2_y:Number):void {
			point_1=new Point(point1_x, point1_y);
			point_2=new Point(point2_x, point2_y);
			handle_1=new Point(handle1_x, handle1_y);
			handle_2=new Point(handle2_x, handle2_y);
			equateCubic(point_1, point_2, handle_1, handle_2);
			with (container.graphics){
				moveTo(points[0].x, points[0].y);
				curveTo(handles[0].x, handles[0].y, points[1].x, points[1].y);
				curveTo(handles[1].x, handles[1].y, points[2].x, points[2].y);
				curveTo(handles[2].x, handles[2].y, points[3].x, points[3].y);
				curveTo(handles[3].x, handles[3].y, points[4].x, points[4].y);
			}
		}
		
		private function equateCubic(p_0:Point, p_4:Point, h_0:Point, h_4:Point):void{
		//slices a cubic bezier into 5 parts, by using the generic midpoint-approach, returns the points:
			handles=new Array();
			points=new Array();
			points[0]=p_0;
			points[4]=p_4;
			handles[0]=Point.interpolate(h_0, p_0, 0.375);
			var h0m=Point.interpolate(h_0, p_0, 0.5);
			handles[3]=Point.interpolate(h_4, p_4, 0.375);
			var h4m=Point.interpolate(h_4, p_4, 0.5);
			
			var h0h4m=Point.interpolate(h_0, h_4, 0.5);
			var h0m_h0h4m_m=Point.interpolate(h0m, h0h4m, 0.5);
			var h4m_h0h4m_m=Point.interpolate(h4m, h0h4m, 0.5);
			points[2]=Point.interpolate(h0m_h0h4m_m, h4m_h0h4m_m, 0.5);
			handles[1]=Point.interpolate(points[2], h0m_h0h4m_m, 0.125);
			handles[2]=Point.interpolate(points[2], h4m_h0h4m_m, 0.125);
			points[1]=Point.interpolate(handles[0], handles[1], 0.5);
			points[3]=Point.interpolate(handles[2], handles[3], 0.5);
		}
		
	}// classs ende
}