﻿package com.bezier{

	import flash.geom.Point;
	import flash.events.Event;
	import com.events.UniversalEvent;

	import flash.events.MouseEvent;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.SimpleButton;

	import flash.filters.DropShadowFilter;

	public class Handle extends Sprite{
		
		private var line:Shape;
		private var handleButton:SimpleButton;
		private var pointButton:SimpleButton;
		private var lineColor:int=0x990000;
		private var handleButtonSize:int=10;
		private var pointSize:int=10;
		private var lineThickness:int=1;
		private var dropShadow:DropShadowFilter = new DropShadowFilter(2, 45, 0x000000, 0.3, 7, 7, 2);
		private var dropShadowFiltersArray:Array = new Array(dropShadow);
		public var coords:Array;
		
		public function Handle(_coords:Array):void {
			
			coords=_coords;
			line=new Shape();
			handleButton=new SimpleButton;
			pointButton=new SimpleButton;
			createhandleButton();
			createPoint(); 
			drawHandle();
			this.addChild(line);
			this.addChild(pointButton);
			this.addChild(handleButton);
			handleButton.filters = dropShadowFiltersArray;
			pointButton.filters = dropShadowFiltersArray;
		}
		
		private function drawHandle():void{
			with (line.graphics){
				clear();
				lineStyle(1, lineColor, 0.4);
				moveTo(coords[2], coords[3]);
				lineTo(coords[0], coords[1]);
			}
			handleButton.x=coords[0];
			handleButton.y=coords[1];
			pointButton.x=coords[2];
			pointButton.y=coords[3];
		}
		
		private function createhandleButton():void{
			var butBgUp=new Shape();
			drawhandleButton(butBgUp, 0xffffff, 0x990000);
			
			var butBgOver=new Shape();
			drawhandleButton(butBgOver, 0x990000, 0xffffff );
			
			var butBgDn=new Shape();
			drawhandleButton(butBgDn, 0xffffff, 0xffffff );
			
			handleButton.upState=butBgUp;
			handleButton.overState=butBgOver;
			handleButton.downState=butBgDn;
			handleButton.hitTestState=butBgDn;
			
			function drawhandleButton(container:Shape, lineCol:int, fillCol:int){
				with (container.graphics){
					clear();
					lineStyle(1, lineCol);
					beginFill(fillCol, 1);
					drawRect((0-handleButtonSize/2), (0-handleButtonSize/2), handleButtonSize, handleButtonSize);
					endFill;
				}
			}
			handleButton.addEventListener(MouseEvent.MOUSE_DOWN, initMove);
			handleButton.addEventListener(MouseEvent.MOUSE_UP, releaseMove);
		}
		
		private function createPoint():void{
			var butBgUp=new Shape();
			drawPoint(butBgUp, 0xffffff, 0x990000);
			
			var butBgOver=new Shape();
			drawPoint(butBgOver, 0x990000, 0xffffff );
			
			var butBgDn=new Shape();
			drawPoint(butBgDn, 0xffffff, 0xffffff );
			
			pointButton.upState=butBgUp;
			pointButton.overState=butBgOver;
			pointButton.downState=butBgDn;
			pointButton.hitTestState=butBgDn;
			
			function drawPoint(container:Shape, lineCol:int, fillCol:int){
				with (container.graphics){
					clear();
					lineStyle(1, lineCol);
					beginFill(fillCol, 1);
					drawCircle(0,0, pointSize/2);
					endFill;
				}
			}
			pointButton.addEventListener(MouseEvent.MOUSE_DOWN, initMove);
			pointButton.addEventListener(MouseEvent.MOUSE_UP, releaseMove);
		}
		
		private var button:Object;
		
		private function initMove(e:Event){
			this.stage.addEventListener(MouseEvent.MOUSE_MOVE, update);
			this.stage.addEventListener(MouseEvent.MOUSE_UP, releaseMove);
			button=e.target;
			button.addEventListener(MouseEvent.MOUSE_MOVE, update);
		}
		
		private function releaseMove(e:Event){
			this.stage.removeEventListener(MouseEvent.MOUSE_MOVE, update);
			button.removeEventListener(MouseEvent.MOUSE_MOVE, update);
		}
		
		function update(e:Event){
			if(button==pointButton){
				coords[0]=handleButton.x=this.mouseX+(coords[0]-coords[2]);
				coords[1]=handleButton.y=this.mouseY+(coords[1]-coords[3]);
				coords[2]=pointButton.x=this.mouseX;
				coords[3]=pointButton.y=this.mouseY;
			}else if(button==handleButton){
				coords[0]=handleButton.x=this.mouseX;
				coords[1]=handleButton.y=this.mouseY;
			}
			drawHandle();
			dispatchEvent(new UniversalEvent(UniversalEvent.CHANGE));
		}
		
	}// classs ende
}