﻿package com.gui.palettes.slider{

	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.filters.DropShadowFilter;

	public class SliderButtonComponent extends SimpleButton {
		
		private var bWidth:uint;
		private var bHeight:uint;
		private var butBgUp:Sprite;
		private var butBgOver:Sprite;
		private var butBgDn:Sprite;
		private var butBgHi:Sprite;
		private var butBgHit:Sprite;
		private var dropShadow:DropShadowFilter = new DropShadowFilter(2, 45, 0x000000, 0.3, 7, 7, 2);
		private var dropShadowFiltersArray:Array = new Array(dropShadow);

		public function SliderButtonComponent():void{
			bWidth=bHeight=16;
			
			butBgUp=new Sprite();
			drawGraphics(butBgUp, 0x990000, 0xffffff, 0);
			
			butBgOver=new Sprite();
			drawGraphics(butBgOver, 0x11fcfe, 0x65585F, 0);
			
			butBgDn=new Sprite();
			drawGraphics(butBgDn, 0x11fcfe, 0xffffff, 2);
			
			butBgHi=new Sprite();
			drawGraphics(butBgHi, 0x990000, 0x11fcfe, 0);
			this.upState=butBgUp;
			this.overState=butBgOver;
			this.downState=butBgDn;
			this.hitTestState=butBgUp;
		}
		
		private function drawGraphics(but:Sprite, col_1:int, col_2:int, pos:Number):void{
			var shape_1:Shape=new Shape();
			shape_1.x=pos;
			shape_1.y=pos;
			var woelbung:Number=bHeight/5;
			with (shape_1.graphics){
				beginFill(col_1, 1);
				moveTo(0,0);
				curveTo(bWidth/2, woelbung, bWidth, 0);
				curveTo(bWidth-woelbung, bHeight/2, bWidth, bHeight);
				curveTo(bWidth/2, bHeight-woelbung, 0, bHeight);
				curveTo(woelbung, bHeight/2, 0, 0);
				endFill();
			}
			shape_1.rotation=45;
			
			
			var shape_2:Shape=new Shape();
			shape_2.x=pos;
			shape_2.y=pos;
			with (shape_2.graphics){
				beginFill(col_2, 1);
				moveTo(0,0);
				curveTo(bWidth/2, woelbung, bWidth, 0);
				curveTo(bWidth-woelbung, bHeight/2, bWidth, bHeight);
				curveTo(bWidth/2, bHeight-woelbung, 0, bHeight);
				curveTo(woelbung, bHeight/2, 0, 0);
				endFill();
			}
			shape_2.rotation=45;
			shape_2.scaleX=shape_2.scaleY=0.5;
			shape_2.y+=(shape_1.height-shape_2.height)/2;
			but.addChild(shape_1);
			but.addChild(shape_2);
			but.filters = dropShadowFiltersArray;
		}

	}
}