﻿package com.gui.palettes.slider{

	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.filters.GlowFilter;
	
    import flash.events.Event;

	import flash.text.TextField;
	import flash.text.TextFormat;
	import com.events.UniversalEvent;
	import com.gui.palettes.slider.SliderButtonContainer;

	public class SliderComponent extends Sprite {

		private var labelTxt:String;
		private var sWidth:uint;
		private var sDigits:uint;
		private var sMinVal:Number;
		private var sMaxVal:Number;
		private var defVal:Number;
		private var resolution:Number;
		private var sHeight:uint=14;
		private var innerGlow:GlowFilter;
		private var innerGlowFiltersArray:Array = new Array();
		private var sValueField:TextField;
		private var targetObj:Object;
		private var addPoints:Boolean;
		private var targetAttr:String;
		private var prevTimer:Number;
		private var frameCounter:Number;
		private var sliderPos:int=130;
		private var sliderButtonContainer:SliderButtonContainer;

		public function SliderComponent(_labelTxt:String, _targetObj:Object, _targetAttr:String, _sWidth:uint, _sDigits:uint, _sMinVal:Number, _sMaxVal:Number, _defVal:Number):void{
			labelTxt=_labelTxt;
			targetObj=_targetObj;
			targetAttr=_targetAttr;
			sWidth = _sWidth;
			//sDigits = _sDigits;
			sMinVal = _sMinVal;
			sMaxVal = _sMaxVal;
			defVal=_defVal;
			resolution=(sMaxVal-sMinVal)/sWidth;
			
			setUpGraphics();
			
			var startVal:Number=calcSliderVal(sliderButtonContainer.x);
			//targetObj[targetAttr]=startVal;
			targetObj.setResolution(startVal);
			sValueField.text=startVal+"";
			targetObj.setResolution(startVal);
		}
		
		private function changeValue(e:UniversalEvent):void{
			var res:uint=calcSliderVal(sliderButtonContainer.x);
			dispatchEvent(new UniversalEvent(UniversalEvent.CHANGE, [res]));
		}
		
		private function calcSliderVal(pos:Number):Number{
			var val=Math.floor((pos-sliderPos)*resolution+sMinVal);
			sValueField.text=val+"";
			return(val);
		}
		
		private function setUpGraphics():void{
			innerGlow = new GlowFilter(0xFF0000, 0.2, 6.0, 6.0, 1, 3, true, false);
			innerGlowFiltersArray[0]=innerGlow;
			var format:TextFormat=new TextFormat();
			format.font="_sans";
			format.size=11;
			
			var sLabelField =new TextField();
			with (sLabelField) {
				defaultTextFormat=format;
				selectable=false;
				htmlText="<span class='but'>"+labelTxt+"</span>";
				width=70;
				height= 20;
				x=50;
				y=-3;
			}
			
			var sliderBG:Sprite=new Sprite();
			sliderBG.x=sliderPos;
			sliderBG.y=sHeight/4;
			sliderBG.filters = innerGlowFiltersArray;
			with (sliderBG.graphics){
				beginFill(0xd2cfbf, 1);
				drawRect(0,0, sWidth, sHeight/2);
				endFill();
			}
			
			var sliderBevel:Shape=new Shape();
			sliderBevel.x=sliderBG.x;
			sliderBevel.y=sliderBG.y;
			
			with (sliderBevel.graphics){
					lineStyle(1,0x000000,1);
					drawPath(
					Vector.<int>([1,2,2]),
					Vector.<Number>([0,sHeight/2, 0,0, sWidth,0])
					);
					
					lineStyle(1,0xffffff,1);
					drawPath(
					Vector.<int>([1,2,2]),
					Vector.<Number>([0,sHeight, sWidth,sHeight/2, sWidth,0])
					);
			}
			
			var infoBG:Sprite=new Sprite();
			infoBG.x=sliderBG.x+sWidth+25;
			infoBG.y=0;
			infoBG.filters = innerGlowFiltersArray;
			with (infoBG.graphics){
				beginFill(0xffffff, 1);
				drawRect(0,0, 34, sHeight);
				endFill();
			}
			
			var infoBGBevel:Shape=new Shape();
			infoBGBevel.x=infoBG.x;
			infoBGBevel.y=infoBG.y;
			
			with (infoBGBevel.graphics){
					lineStyle(1,0xA1825A,1);
					drawPath(
					Vector.<int>([1,2,2]),
					Vector.<Number>([0,sHeight, 0,0, infoBG.width,0])
					);
					
					lineStyle(1,0xffffff,1);
					drawPath(
					Vector.<int>([1,2,2]),
					Vector.<Number>([0,sHeight, infoBG.width,sHeight, infoBG.width,0])
					);
			}
			
			sValueField =new TextField();
			with (sValueField) {
				selectable=true;
				border=false;
				width=43;
				height=sHeight+3;
				x=infoBG.x+5;
				y=0;
			}
			
			sliderButtonContainer=new SliderButtonContainer(sliderPos,-sHeight/2+2, sWidth, 0);
			sliderButtonContainer.x=Math.floor(sWidth*defVal/100)+sliderPos;
			sliderButtonContainer.addEventListener(UniversalEvent.CHANGE, changeValue);
			sliderButtonContainer.y=-sHeight/2+2;
			
			this.addChild(sLabelField);
			this.addChild(sliderBG);
			this.addChild(infoBG);
			this.addChild(infoBGBevel);
			this.addChild(sValueField);
			this.addChild(sliderButtonContainer);
		}
		
	}
}